--- alsa-info.txt.4.3-rc6.before	2015-10-22 23:41:24.265081408 +0300
+++ alsa-info.txt.4.3-rc6.after	2015-10-22 23:46:30.584791012 +0300
@@ -3,7 +3,7 @@
 !!ALSA Information Script v 0.4.64
 !!################################
 
-!!Script ran on: Thu Oct 22 20:41:23 UTC 2015
+!!Script ran on: Thu Oct 22 20:46:30 UTC 2015
 
 
 !!Linux Distribution
@@ -142,26 +142,26 @@
     ControlAmp: chs=3, dir=Out, idx=0, ofs=0
   Device: name="ALC3260 Analog", type="Audio", device=0
   Amp-Out caps: ofs=0x3f, nsteps=0x40, stepsize=0x03, mute=0
-  Amp-Out vals:  [0x25 0x25]
-  Converter: stream=5, channel=0
+  Amp-Out vals:  [0x21 0x21]
+  Converter: stream=0, channel=0
   PCM:
     rates [0x560]: 44100 48000 96000 192000
     bits [0xe]: 16 20 24
     formats [0x1]: PCM
   Power states:  D0 D1 D2 D3 EPSS
-  Power: setting=D0, actual=D0
+  Power: setting=D3, actual=D3
 Node 0x03 [Audio Output] wcaps 0x41d: Stereo Amp-Out
   Control: name="Speaker Playback Volume", index=0, device=0
     ControlAmp: chs=3, dir=Out, idx=0, ofs=0
   Amp-Out caps: ofs=0x3f, nsteps=0x40, stepsize=0x03, mute=0
-  Amp-Out vals:  [0x25 0x25]
-  Converter: stream=5, channel=0
+  Amp-Out vals:  [0x21 0x21]
+  Converter: stream=0, channel=0
   PCM:
     rates [0x560]: 44100 48000 96000 192000
     bits [0xe]: 16 20 24
     formats [0x1]: PCM
   Power states:  D0 D1 D2 D3 EPSS
-  Power: setting=D0, actual=D0
+  Power: setting=D3, actual=D3
 Node 0x04 [Vendor Defined Widget] wcaps 0xf00000: Mono
 Node 0x05 [Vendor Defined Widget] wcaps 0xf00000: Mono
 Node 0x06 [Audio Output] wcaps 0x611: Stereo Digital
@@ -182,7 +182,7 @@
     ControlAmp: chs=3, dir=In, idx=0, ofs=0
   Device: name="ALC3260 Analog", type="Audio", device=0
   Amp-In caps: ofs=0x11, nsteps=0x2e, stepsize=0x03, mute=1
-  Amp-In vals:  [0x11 0x11]
+  Amp-In vals:  [0x10 0x10]
   Converter: stream=0, channel=0
   SDI-Select: 0
   PCM:
@@ -240,7 +240,7 @@
 Node 0x10 [Vendor Defined Widget] wcaps 0xf00000: Mono
 Node 0x11 [Audio Input] wcaps 0x10051b: Stereo Amp-In
   Amp-In caps: ofs=0x11, nsteps=0x2e, stepsize=0x03, mute=1
-  Amp-In vals:  [0x11 0x11]
+  Amp-In vals:  [0x10 0x10]
   Converter: stream=1, channel=0
   SDI-Select: 0
   PCM:
@@ -288,7 +288,7 @@
     Misc = NO_PRESENCE
   Pin-ctls: 0x40: OUT
   Power states:  D0 D1 D2 D3 EPSS
-  Power: setting=D0, actual=D0
+  Power: setting=D3, actual=D3
   Connection: 2
      0x0c 0x0d*
 Node 0x15 [Pin Complex] wcaps 0x40058d: Stereo Amp-Out
@@ -531,8 +531,8 @@
 crw-rw----+ 1 root audio 116,  2 Oct 22 23:40 /dev/snd/controlC0
 crw-rw----+ 1 root audio 116,  6 Oct 22 23:40 /dev/snd/hwC0D0
 crw-rw----+ 1 root audio 116,  7 Oct 22 23:40 /dev/snd/hwC0D3
-crw-rw----+ 1 root audio 116,  4 Oct 22 23:40 /dev/snd/pcmC0D0c
-crw-rw----+ 1 root audio 116,  3 Oct 22 23:40 /dev/snd/pcmC0D0p
+crw-rw----+ 1 root audio 116,  4 Oct 22 23:46 /dev/snd/pcmC0D0c
+crw-rw----+ 1 root audio 116,  3 Oct 22 23:45 /dev/snd/pcmC0D0p
 crw-rw----+ 1 root audio 116,  5 Oct 22 23:40 /dev/snd/pcmC0D3p
 crw-rw----+ 1 root audio 116,  1 Oct 22 23:40 /dev/snd/seq
 crw-rw----+ 1 root audio 116, 33 Oct 22 23:40 /dev/snd/timer
@@ -578,7 +578,7 @@
   Capabilities: pvolume pvolume-joined pswitch pswitch-joined
   Playback channels: Mono
   Limits: Playback 0 - 64
-  Mono: Playback 38 [59%] [-26.00dB] [on]
+  Mono: Playback 34 [53%] [-30.00dB] [on]
 Simple mixer control 'Headphone',0
   Capabilities: pvolume pswitch
   Playback channels: Front Left - Front Right
@@ -598,8 +598,8 @@
   Playback channels: Front Left - Front Right
   Limits: Playback 0 - 255
   Mono:
-  Front Left: Playback 255 [100%] [0.00dB]
-  Front Right: Playback 255 [100%] [0.00dB]
+  Front Left: Playback 253 [99%] [-0.40dB]
+  Front Right: Playback 253 [99%] [-0.40dB]
 Simple mixer control 'Mic',0
   Capabilities: pvolume pswitch
   Playback channels: Front Left - Front Right
@@ -629,8 +629,8 @@
   Capabilities: cvolume cswitch
   Capture channels: Front Left - Front Right
   Limits: Capture 0 - 46
-  Front Left: Capture 17 [37%] [0.00dB] [on]
-  Front Right: Capture 17 [37%] [0.00dB] [on]
+  Front Left: Capture 16 [35%] [-1.00dB] [on]
+  Front Right: Capture 16 [35%] [-1.00dB] [on]
 Simple mixer control 'Auto-Mute Mode',0
   Capabilities: enum
   Items: 'Disabled' 'Enabled'
@@ -745,8 +745,8 @@
 	control.8 {
 		iface MIXER
 		name 'Capture Volume'
-		value.0 17
-		value.1 17
+		value.0 16
+		value.1 16
 		comment {
 			access 'read write'
 			type INTEGER
@@ -754,8 +754,8 @@
 			range '0 - 46'
 			dbmin -1700
 			dbmax 2900
-			dbvalue.0 0
-			dbvalue.1 0
+			dbvalue.0 -100
+			dbvalue.1 -100
 		}
 	}
 	control.9 {
@@ -804,7 +804,7 @@
 	control.12 {
 		iface MIXER
 		name 'Master Playback Volume'
-		value 38
+		value 34
 		comment {
 			access 'read write'
 			type INTEGER
@@ -812,7 +812,7 @@
 			range '0 - 64'
 			dbmin -6400
 			dbmax 0
-			dbvalue.0 -2600
+			dbvalue.0 -3000
 		}
 	}
 	control.13 {
@@ -999,8 +999,8 @@
 	control.29 {
 		iface MIXER
 		name 'PCM Playback Volume'
-		value.0 255
-		value.1 255
+		value.0 253
+		value.1 253
 		comment {
 			access 'read write user'
 			type INTEGER
@@ -1009,8 +1009,8 @@
 			tlv '0000000100000008ffffec1400000014'
 			dbmin -5100
 			dbmax 0
-			dbvalue.0 0
-			dbvalue.1 0
+			dbvalue.0 -40
+			dbvalue.1 -40
 		}
 	}
 }
@@ -1021,6 +1021,8 @@
 !!------------------
 
 Module
+alx
+mdio
 cmac
 rfcomm
 bnep
@@ -1131,11 +1133,9 @@
 psmouse
 ahci
 sdhci_pci
-alx
 rtsx_pci
 libahci
 sdhci
-mdio
 floppy
 
 